# -*- coding: utf-8 -*-
# Tässä pelissä läiskitään ympäriinsä lenteleviä hyttysiä

import pygame
import random
from math import sqrt
Musta = (0, 0, 0)  # Mustassa ei ole mitään valoa
Sin = (0, 0, 255)  # vain sinistä
Pun = (255, 0, 0)
Vihr = (0, 255, 0)
Valk = (255, 255, 255)  # valkoisessa on kaikenväristä valoa
Tausta = (160, 200, 255)

# Peli-ikkunan koko pikseleinä. Pikseli on piste näytöllä.
# Wx = 800
# Wy = 600
# Wxy = (Wx, Wy)  # peli-ikkunan korkeus ja leveys

Nayttotaajuus = 48  # Voit kokeilla eri näyttötaajuuksia
Dt = 1.0/Nayttotaajuus

# Peliin liittyviä muuttujia.
VLatka = 200.0  # Lätkän nopeus
# __init__(self, x, y, koko) on metodi, jolla lätkä luodaan


class Cl_Latka:
    def __init__(self, x, y, koko):
        self.paikka = (x, y)
        self.koko = koko
        self.color = Vihr
        self.liikkuu = False

    def piirra(self):
        (x, y) = self.paikka
        iPaikka = (int(x), int(y))
        pygame.draw.circle(screen, self.color, iPaikka, self.koko, 0)
        pygame.draw.circle(screen, Pun, iPaikka, int(self.koko/2), 0)

    def liiku(self, vxvy):
        (x, y) = self.paikka
        (vx, vy) = vxvy
        (x, y) = (x + vx*Dt, y + vy*Dt)
        if x > Wx:
            x = 0
        elif x < 0:
            x = Wx
        if y > Wy:
            y = 0
        elif y < 0:
            y = Wy

        # Lisäämällä tähän väliin muutaman if lauseen, voit korjata ohjelmaa
        #  niin, että Lätkä ei karkaa peli-ikkunan reunan ulkopuolelle
        # jos x on suurempi kuin niin Wx x.stä kannattaa vähentää Wx jne...
        self.paikka = (x, y)
        self.liikkuu = True

# # # # # # # # # # # # # # # # # # # # # # # # # # #
# Pääohjelma alkaa tästä
# # # # # # # # # # # # # # # # # # # # # # # # # # #


pygame.display.init()
# Selvitetään peli-ikkunan koko näytöllä pikseleinä. Pikseli on piste näytöllä.
D_Info = pygame.display.Info()
Wx = D_Info.current_w
Wy = int(0.9*D_Info.current_h)
Wxy = (Wx, Wy)  # peli-ikkunan korkeus ja leveys

screen = pygame.display.set_mode((Wx, Wy))
pygame.display.set_caption(
    "Hyttysjahti")
pygame.init()
clock = pygame.time.Clock()
random.seed()

# Luodaan 'olio' tyyppiä Cl_latka
Latka = Cl_Latka(Wx-50, Wy-50, 30)

#
# Toistetaan allaolevaa while-silmukkaa, kunnes käyttäjä sulkee peli-ikkunan
# tai painaa ESC-iä
#

pygame.mixer.init(frequency=22050, size=-16, channels=2, buffer=512)

inina = pygame.mixer.music.load('Hyttynen_tasainen_inina.wav')
liiskaus = pygame.mixer.Sound('Hyttysen_liiskaus.wav')

loppu = False

pygame.mixer.music.play(-1)

while not loppu:

    clock.tick(Nayttotaajuus)

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            loppu = True
        if event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
            loppu = True

    screen.fill(Tausta)


    Latka.liikkuu = False

#   Tarkistetaan, onko joku tai jotkin lätkää ohjaavista näppäimistä
# painettuna. Liikutetaan lätkää vastaavasti.
    pressed = pygame.key.get_pressed()
    if pressed[pygame.K_RIGHT]:
        Latka.liiku((0.0, -VLatka))  # ylös
    if pressed[pygame.K_LEFT]:
        Latka.liiku((0.0, VLatka))  # alas
    if pressed[pygame.K_z]:
        Latka.liiku((-VLatka, 0.0))  # vasemmalle
    if pressed[pygame.K_x]:
        Latka.liiku((VLatka, 0.0))  # oikealle
    if pressed[pygame.K_KP_PLUS]:
        VLatka = 1.1*VLatka
    if pressed[pygame.K_KP_MINUS]:
        VLatka = 0.9*VLatka

    # Piirretään lätkä uudelle paikalleen
    Latka.piirra()
    # näytetään kaikki yllä 'piirretty' näytöllä
    pygame.display.flip()
    #
    # while silmukka päättyy tähän
#
# Ohjelman loppu


pygame.quit()

